'Czytnik bezstykowych kart
'Marcin Wizania

$noramclear
$crystal = 4000000
$baud = 9600

Config Watchdog = 2048
Stop Watchdog

Config Pind.2 = Output
Config Pind.3 = Output
Config Pinb.6 = Output
Config Pinb.7 = Output
Config Pind.6 = Output
Config Pind.4 = Input
Config Pind.5 = Input

Clk Alias Portd.3
Dat Alias Portd.2
Dat1 Alias Pind.2
Red Alias Portb.6
Green Alias Portb.7
Pk Alias Portd.6
Pk1 Alias Pind.6
Jp1 Alias Pind.4
Jp2 Alias Pind.5

Declare Sub Sprawdz
Declare Sub Write_k
Declare Sub Read_t
Declare Sub Start_r
Dim Dane(11) As Byte
Dim Cclk As Bit
Dim Ddat As Bit
Dim J As Byte
Dim I As Byte
Dim Temp1 As Byte
Dim Wysl As Byte
Dim Spr As Byte
Dim Zakres As Byte
Dim Kod As Bit
Dim K As Byte
Dim Temp2 As Byte
Dim Error As Bit
Dim Temp3 As Byte

Reset Pk                                                    'odpowiednie ustawienie linii
Reset Green
Set Red
Set Portd.4
Set Portd.5

Do
  Call Start_r                                              'wyslij rozkazy do asic
  Call Read_t                                               'odczyt danych z karty
  Call Sprawdz                                              'sprawdzenie poprawnosci danych
  If Error = 0 Then                                         'jesli error=0 to
    Green = Not Green                                       'zmien stan linii green
    Red = Not Red                                           'zmien stan linii red
    For I = 1 To 11                                         'wykonuj petle az i=11
      Print Dane(i) ; " ";                                  'wyslij dane odczytane z karty przez rs232
    Next I
    Print
    Waitms 250                                              'czekaj
    Call Start_r                                            'wyslij rozkazy do asic
    Red = Not Red                                           'zmiena stan linii red
    Green = Not Green                                       'zmien stan linii green
  End If
  Temp2 = Inkey()                                           'zapisz odebrany znak przez rs232 do zmiennej temp2
  If Temp2 = "1" Or Temp2 = "0" Then                        'jesli odebrany znak jest rozmowazny kodom ascii liczb 1 lub 2 i
    Print "ok"                                              'wyslij przez rs232 wartosc "ok"
    If Temp2 = "1" Then                                     'jesli zostal byslany znak "1"
      If Jp2 = 1 Then                                       'jesli zworka jp1 jest rozwarta
        Reset Red                                           'to zeruj linie red
        Set Green                                           'ustaw linie green
        Set Pk                                              'zalacz przekaznik
        For K = 1 To 20                                     'wykonuj petle az k=20
          Call Start_r                                      'wyslij rozkaz do asic
          Waitms 500                                        'czekaj
        Next K
        Reset Green                                         'zeruj linie green
        Set Red                                             'ustaw linie red
        Reset Pk                                            'wylacz przekaznik
      Else                                                  'w przeciwnym razie gdy jp1 jest zwarta
        Set Pk                                              'zalacz przekaznik
        Reset Red                                           'zeruj linie red
        Set Green                                           'ustaw linie green
      End If
    Else                                                    'w przeciwnym razie gdy odebrany kod wynosi "0"
      Reset Pk                                              'wylacz przekaxnik
      Reset Green                                           'zeruj linie green
      Set Red                                               'ustaw linie red
    End If
  End If
  Call Start_r                                              'wyslij polecenie do asic
  Waitms 400
Loop
End

Sub Start_r                                                 'Procedure wysylajaca dwa rozkazy do ASIC
   Wysl = &B00001001                                        'kod rozkazu zerowania watchdoga
   Zakres = 3                                               'ilosc bitow do wyslania
   Call Write_k                                             'wyslanie rozkazu do ASIC
   For I = 1 To 11                                          'odpowiednie ustawienie zmiennych dane(i)
     Dane(i) = I
   Next I
   Wysl = &B00000001                                        'kod rozkazu odczytu danych z karty
   Call Write_k                                             'wyslanie kodu
   Waitms 10
End Sub

Sub Read_t                                                  'procedura odczytu danych z transpondera ( z karty)
  Reset Kod                                                 'zeruj flage kod
  Set Cclk                                                  'ustaw flage cclk
  Do                                                        'czekaj az linia dat osiagnie stan 0
  Loop Until Dat1 = 0
  Do                                                        'czekaj az linia dat osiagnie stan 1
  Loop Until Dat1 = 1
  Temp3 = 0
  Do
    J = 0
    If Dat1 = 0 Then                                        'jezeli linia dat=0 to
      Do
        Incr J                                              'zwieksz zmienna j
        If J = 47 Then                                      'jezeli zmienna j=47 to wyjdz z petli do-looop
          Exit Do
        End If
      Loop Until Dat1 = 1                                   'wyjscie z petli takze gdy linia dat=1
      Cclk = Not Cclk                                       'zmien stan flagi cclk
    Else                                                    'w przeciwnym razie
      Do
        Incr J                                              'zwieksz zmienna j
        If J = 47 Then                                      'jezeli zmienna j=47 to wyjdz z petli do-loop
          Exit Do
        End If
      Loop Until Dat1 = 0                                   'wyjscie z petli takze gdy linia dat=0
      Cclk = Not Cclk                                       'zmien stan flagi cclk
    End If
    Ddat = Dat1 Xor Cclk                                    'dekoduj odczytany stan funkcja xor
    If Cclk = 0 Then                                        'jezeli flaga cclk=0 to
      If Kod = 1 Then                                       'i jezeli kod=1 to
        Spr = Dane(i)                                       'zapisz do zmiennej spr okreslone indeksem dane
        Spr.k = Ddat                                        'zapisz do pozycji okreslonej zmienna k stan flagi ddat
        Dane(i) = Spr                                       'zapisz zmienna spr do danych okreslonych indeksem
        Decr K                                              'zmniejsz zmienna k
        If K = 255 Then                                     'jezeli zmienna k=255 to
          K = 4                                             'zapisz do nie wartosc 4
          Incr I                                            'zwieksz zmienna i
        End If
      End If
      If Kod = 0 Then                                       'jesli kod=0 to
        If Ddat = 1 Then                                    'i jesli ddat=1 to
          Incr Spr                                          'zwieksz zmienna spr
          If Spr = 9 Then                                   'jesli spr=9 to
            Temp3 = 0                                       'zeruj zmienna temp3
            Set Kod                                         'ustaw flage kod
            I = 1                                           'zapisz do zmiennej i wartosc 1
            K = 4                                           'a do zmiennej k wartosc 4
          End If
        Else                                                'w przeciwnym razie
          Spr = 0                                           'zeruj zmienna spr
        End If
      End If
    End If
    Incr Temp3                                              'zwieksz wartosc temp3
  Loop Until I = 12 Or Temp3 = 180                          'zakoncz procedure gdy i=12 lub temp3=180
End Sub

Sub Write_k                                                 'rpcedura przeslania rozkazu do ASIC
  Config Pind.2 = Output                                    'ustaw linie danych jako wyjcie
  Reset Clk                                                 'zeruj linie clk
  Reset Dat                                                 'zeruj linie dat
  Waitus 10                                                 'czekaj
  Set Clk                                                   'ustaw linie clk
  Waitus 10                                                 'czekaj
  Set Dat                                                   'ustaw linie dat
  Waitus 10                                                 'czekaj
  Reset Clk                                                 'zeruj linie clk
  Waitus 10
  For I = 0 To Zakres                                       'wysylaj az i osiagnie wartosc zmiennej zakres
    If Wysl.i = 1 Then                                      'jesli bit oznaczony indeksem i jest ustawiony to
      Set Dat                                               'ustaw linie dat
    Else                                                    'w przeciwnym razie
      Reset Dat                                             'zeruj linie dat
    End If
    Waitus 10                                               'czekaj
    Set Clk                                                 'ustaw linie clk
    Waitus 20                                               'czekaj
    Reset Clk                                               'zeruj linie clk
    Waitus 10                                               'czekaj
  Next I
  Reset Dat                                                 'zeruj linie dat
  If Wysl = 9 Then                                          'jesli do wyslania wartosc rowna 9 to
    Waitus 30                                               'czekaj
    Set Dat                                                 'ustaw linie dat
    Waitus 20                                               'czekaj
    Reset Dat                                               'zeruj linie dat
  End If
  Waitms 1                                                  'czekaj
  Config Pind.2 = Input                                     'ustaw linie dat jako wejscie
End Sub

Sub Sprawdz                                                 'sprawdzenie poprawnosci odczytanego z karty kodu
  Error = 0                                                 'zeruj flage error
  For J = 1 To 10                                           'wykonyj az j osiagnie wartosc 10
    Spr = 0                                                 'zeruj zmienna spr
    Temp1 = Dane(j)                                         'zapisz dane okreslone indeksem j do zmiennej temp1
    For I = 1 To 4                                          'wykonuj petle az i=4
      If Temp1.i = 1 Then                                   'jesli bit zmiennej temp1 wstazywany przez i rowna sie 1
        Incr Spr                                            'to zwieksz spr
      End If
    Next I
    Spr = Spr Mod 2                                         'sprawdz parzystosc jedynek w zmiennej spr
    Temp1 = Dane(j)                                         'zapisz do temp1 dane wskazywane przez j
    If Spr.0 <> Temp1.0 Then                                'jezeli bity rozne to ustaw
       Error = 1                                            'flage error
    End If
  Next J
  For I = 1 To 4                                            'wykonuj petle az i=4
    Spr = 0                                                 'zeruj spr
    For J = 1 To 10                                         'wykonuj petle az j=10
      Temp1 = Dane(j)                                       'zapisz do zmiennej temp1 wartosc dane okreslone przez indeks j
      If Temp1.i = 1 Then                                   'jesli bit temp1 okreslony przez i rowny jest 1
         Incr Spr                                           'to zwieksz spr
      End If
    Next J
    Spr = Spr Mod 2                                         'sprawdz parzystosc jedynek w zmiennej spr
    Temp1 = Dane(11)                                        'zapisz do zmiennej temp1 wartosc dane(11)
    If Spr.0 <> Temp1.i Then                                'jezeli bity sa rozne to ustaw
       Error = 1                                            'flage error
    End If
  Next I
End Sub